require "player"
require "gui"
require "enemy"

sys = {}
sys.state = 0 -- ingame 0 -- menu 2 -- pause
function sys:getState(num)
	if num then return num == self.state 
	else return self.state end 
end
function sys:setState(num)
	self.state = num
end

function sys:save(num)
	local saved = false
	local score = love.filesystem.read("savefile")
	if not tonumber(score) or num > tonumber(score) then 
		while not saved do 
			saved = love.filesystem.write("savefile",tostring(num))
		end
	end
end

function sys:load()
	return love.filesystem.read("savefile")
end


function restart()
	enemy.a = {}
	p.score = 0
	p.x = 32
	p.y = 0
	p.xvel = 0
	p.yvel = 40
	p.health = 1
	sys:setState(0)
end







function love.load()
	love.graphics.setBackgroundColor(101,101,101)
	bg = love.graphics.newImage("assets/mainbg3.png") -- menu
	bg2 = love.graphics.newImage("assets/bg_nobuttons.png") -- ingame
	font = love.graphics.newFont("assets/8bitoperator.ttf",19)
	love.graphics.setFont(font)
	easteregg,eggc,egg2 = 3,1,{"i","m"," ","g","o","d"}
	_debug = false
end

function love.keypressed(k)
	if k == "escape" then love.event.push("quit") end 
	
	
	
	if sys:getState(0) then
	 
		if k == "6" then   
			easteregg = easteregg - 1			--///
			if easteregg == 0 then 				--///
				msg:say("super jump ON",1)	--///
				superjump=true					--///
				p.jumpheight = 600				--///
			end
		elseif k == egg2[eggc] then 
			if eggc < 6 then 
				eggc = eggc + 1 
			elseif eggc == 6 then
				msg:say("Health boost ON",1)
				healthboost=true
				p.health = 666
			end -- end menu / ingame
		elseif k == "k" then
			if _debug == false then 
				_debug = true
				msg:say("Debug mode ON",1)
			else _debug = false; msg:say("Debug mode OFF",2) end
		elseif k == "q" then love.event.push("quit") end 
		
		
	elseif sys:getState(1) then -- ingame 
	
	
		if k == "k" then enemy:spawn(0)
		
		elseif k == "q" then restart()
		
		elseif k == "p" then sys:setState(2)end 
		
	elseif sys:getState(2) then 
	
		if k == "p" then sys:setState(1) end
		 
	end
end


function love.mousepressed(x,y,b)
	if b == "l" then 
		buttons:click(sys:getState(0),x,y)
	end
end

function love.mousereleased(x,y,b)
	if b == "l" then 
		buttons:release(sys:getState(0),x,y)
	end
end


function love.update(dt)
	p:update(sys:getState(1),dt)
	enemy:update(sys:getState(1),dt)
	msg:update(sys:getState(0),dt)
end

function love.draw()
	love.graphics.draw(bg)
	if sys:getState(1) or sys:getState(2) then love.graphics.draw(bg2) end 
	
	p:draw(sys:getState(1) or sys:getState(2))
	enemy:draw(sys:getState(1) or sys:getState(2))
	
	buttons:draw(sys:getState(0))
	msg:draw(sys:getState(0))
end
