
local k = love.keyboard
local gravity = 400

p = {
	pic = love.graphics.newImage("assets/dog2.png"),
	x=32,
	y=0,
	w=64,
	h=64,
	xvel = 0,
	yvel = 40,
	speed = 1200,
	jumpheight=300,
	friction = 8,
	score = 0,
	health = 1
}

p.pic:setFilter("nearest","nearest")



function p:move(dt)
	if (k.isDown("d") or k.isDown("right")) and self.xvel < self.speed then 
		self.xvel = self.xvel + self.speed * dt  
	elseif (k.isDown("a") or k.isDown("left")) and self.xvel > -self.speed then 
		self.xvel = self.xvel - self.speed * dt 
	end
	
	if k.isDown("w") or k.isDown(" ") or k.isDown("up") then
		if self.yvel == 0 then 
			self.yvel = self.yvel + self.jumpheight
		end
	end	
	
end

function p:phys(dt) -- updates to player values
	self.x = self.x + self.xvel * dt
	if self.yvel ~= 0 then 
		self.y = self.y - self.yvel * dt 
		self.yvel = self.yvel - gravity * dt 
		if self.y >= 480 - self.h then 
			self.yvel = 0
			self.y = 480 - self.h
		end
	end
	self.xvel = self.xvel * (1 - math.min(dt*self.friction,1))
	if self.x <= 0 then self.x = 0 end 
	if self.x >= 480 - self.h then self.x = 480 - self.h end 
end


function p:update(s,dt)
	if s then 
	
		self:move(dt)
		self:phys(dt)
		
		if self.health <= 0 then
			sys:save(self.score)
			restart()
		end 
		
		if not _debug and not superjump and not healthboost then
			self.score = self.score + dt*2 
		end 

	end
end



function p:draw(s)
	if s then 
		if superjump or _debug then love.graphics.rectangle("line",self.x+10,self.y+10,44,30) end 
		love.graphics.setColor(0,0,0)
		local str = "Score: "..math.floor(p.score)
		local len = str:len()
		love.graphics.print(str,len)
		love.graphics.setColor(255,255,255)
		love.graphics.draw(self.pic,self.x,self.y,0,2,2)
	end
end
